/*
 * Mattermost API Reference
 *
 * There is also a work-in-progress [Postman API reference](https://documenter.getpostman.com/view/4508214/RW8FERUn).
 *
 * The version of the OpenAPI document: 4.0.0
 * Contact: feedback@mattermost.com
 * Generated by: https://openapi-generator.tech
 */

#[derive(Clone, Debug, PartialEq, Default, serde::Serialize, serde::Deserialize)]
pub struct CreateOAuthAppRequest {
    /// The name of the client application
    #[serde(rename = "name")]
    pub name: String,
    /// A short description of the application
    #[serde(rename = "description")]
    pub description: String,
    /// A URL to an icon to display with the application
    #[serde(rename = "icon_url", skip_serializing_if = "Option::is_none")]
    pub icon_url: Option<String>,
    /// A list of callback URLs for the appliation
    #[serde(rename = "callback_urls")]
    pub callback_urls: Vec<String>,
    /// A link to the website of the application
    #[serde(rename = "homepage")]
    pub homepage: String,
    /// Set this to `true` to skip asking users for permission
    #[serde(rename = "is_trusted", skip_serializing_if = "Option::is_none")]
    pub is_trusted: Option<bool>,
}

impl CreateOAuthAppRequest {
    pub fn new(
        name: String,
        description: String,
        callback_urls: Vec<String>,
        homepage: String,
    ) -> CreateOAuthAppRequest {
        CreateOAuthAppRequest {
            name,
            description,
            icon_url: None,
            callback_urls,
            homepage,
            is_trusted: None,
        }
    }
}
